=== debian/changelog ===
grass (8.4.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2, no changes.
  * Fix old FSF address in copyright file.
  * Update lintian overrides.
  * Mark grass{,-dev}-doc as Multi-Arch: foreign.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 21 Nov 2025 18:41:42 +0100
